diff --git a/xen/include/xen/bitmap.h b/xen/include/xen/bitmap.h
index 6ee39aa35ac6..f8ef85541a84 100644
--- a/xen/include/xen/bitmap.h
+++ b/xen/include/xen/bitmap.h
@@ -103,18 +103,16 @@ extern int bitmap_allocate_region(unsigned long *bitmap, int pos, int order);
 #define bitmap_switch(nbits, zero, small, large)			  \
 	unsigned int n__ = (nbits);					  \
 	if (__builtin_constant_p(nbits) && !n__) {			  \
-		/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */ \
 		zero;							  \
 	} else if (__builtin_constant_p(nbits) && n__ <= BITS_PER_LONG) { \
-		/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */ \
 		small;							  \
 	} else {							  \
-		/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */ \
 		large;							  \
 	}
 
 static inline void bitmap_zero(unsigned long *dst, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = 0UL,
 		memset(dst, 0, bitmap_bytes(nbits)));
@@ -139,6 +137,7 @@ static inline void bitmap_fill(unsigned long *dst, unsigned int nbits)
 static inline void bitmap_copy(unsigned long *dst, const unsigned long *src,
 			unsigned int nbits)
 {
+        /* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = *src,
 		memcpy(dst, src, bitmap_bytes(nbits)));
@@ -147,6 +146,7 @@ static inline void bitmap_copy(unsigned long *dst, const unsigned long *src,
 static inline void bitmap_and(unsigned long *dst, const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = *src1 & *src2,
 		__bitmap_and(dst, src1, src2, nbits));
@@ -155,6 +155,7 @@ static inline void bitmap_and(unsigned long *dst, const unsigned long *src1,
 static inline void bitmap_or(unsigned long *dst, const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = *src1 | *src2,
 		__bitmap_or(dst, src1, src2, nbits));
@@ -163,6 +164,7 @@ static inline void bitmap_or(unsigned long *dst, const unsigned long *src1,
 static inline void bitmap_xor(unsigned long *dst, const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = *src1 ^ *src2,
 		__bitmap_xor(dst, src1, src2, nbits));
@@ -171,6 +173,7 @@ static inline void bitmap_xor(unsigned long *dst, const unsigned long *src1,
 static inline void bitmap_andnot(unsigned long *dst, const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = *src1 & ~*src2,
 		__bitmap_andnot(dst, src1, src2, nbits));
@@ -179,6 +182,7 @@ static inline void bitmap_andnot(unsigned long *dst, const unsigned long *src1,
 static inline void bitmap_complement(unsigned long *dst, const unsigned long *src,
 			unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,,
 		*dst = ~*src & BITMAP_LAST_WORD_MASK(nbits),
 		__bitmap_complement(dst, src, nbits));
@@ -187,6 +191,7 @@ static inline void bitmap_complement(unsigned long *dst, const unsigned long *sr
 static inline int bitmap_equal(const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,
 		return -1,
 		return !((*src1 ^ *src2) & BITMAP_LAST_WORD_MASK(nbits)),
@@ -196,6 +201,7 @@ static inline int bitmap_equal(const unsigned long *src1,
 static inline int bitmap_intersects(const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,
 		return -1,
 		return ((*src1 & *src2) & BITMAP_LAST_WORD_MASK(nbits)) != 0,
@@ -205,6 +211,7 @@ static inline int bitmap_intersects(const unsigned long *src1,
 static inline int bitmap_subset(const unsigned long *src1,
 			const unsigned long *src2, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,
 		return -1,
 		return !((*src1 & ~*src2) & BITMAP_LAST_WORD_MASK(nbits)),
@@ -213,6 +220,7 @@ static inline int bitmap_subset(const unsigned long *src1,
 
 static inline int bitmap_empty(const unsigned long *src, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,
 		return -1,
 		return !(*src & BITMAP_LAST_WORD_MASK(nbits)),
@@ -221,6 +229,7 @@ static inline int bitmap_empty(const unsigned long *src, unsigned int nbits)
 
 static inline int bitmap_full(const unsigned long *src, unsigned int nbits)
 {
+	/* SAF-7-safe Rule 20.7 non-parenthesized macro argument */
 	bitmap_switch(nbits,
 		return -1,
 		return !(~*src & BITMAP_LAST_WORD_MASK(nbits)),